/*******************************************************************
 * This is a demonstration of the use of overloaded functions
 *******************************************************************/

#include<iostream>
#include<string>
#include<vector>
#include<string>
using namespace std;
/* The vector cross product */	
vector<float> cross(vector<float> a, vector<float> b)
{
	vector<float> ret;
	ret.push_back(a[1]*b[2]-a[2]*b[1]);
	ret.push_back(a[2]*b[0]-a[0]*b[2]);
	ret.push_back(a[0]*b[1]-a[1]*b[0]);
	return ret;
}

/* The set cross product */ 
vector<string> cross(const vector<string>& a, const vector<string> & b)
{
	typedef vector<string>::const_iterator vec_iter;
	vector<string> ret;
	for( vec_iter i=a.begin();i!=a.end(); i++)
		for( vec_iter j=b.begin();j!=b.end(); j++)
			ret.push_back("("+*i+", "+*j+")");
	return ret;
}

template <class seq>
void show(const seq & s)
{
	for(typename seq::const_iterator it=s.begin(); it<s.end(); it++)
		cout<<*it<<" ";
}
	
	


int main()
{
	float x;
	vector<float> v1, v2;
	string word;
	vector<string> s1, s2;
	cout<<"Please three floating point values: ";
	for(int i=0; i<3; i++)
	{
		cin>>x;
		v1.push_back(x);
	}
	cout<<"Please another three floating point values: ";
	for(int i=0; i<3; i++)
	{
		cin>>x;
		v2.push_back(x);
	}
	cout<<"The cross-product of those vectors is ";
	show(cross(v1,v2));
	cout<<endl;

	cout<<"Please enter two words: ";
	for(int i=0; i<2; i++)
	{
		cin>>word;
		s1.push_back(word);
	}
	cout<<"Please enter another three words: ";
	for(int i=0; i<3; i++)
	{
		cin>>word;
		s2.push_back(word);
	}
	cout<<"The cross-product of those sets is ";
	show(cross(s1,s2));
	cout<<endl;

	return 0;
}


